#!/usr/bin/perl
####################   ####################
# icl.cgi           # #                   #
# Interactive        #    unsatisfactory  #
# DTT Channel List   #          software  #
# Chris Young       # #  (c) 2003-2011    #
####################   ####################
# http://www.unsatisfactorysoftware.co.uk #
#      chris@unsatisfactorysoftware.co.uk #
###########################################
$ver = "\$ver: icl 15.1 (22.04.2011)";

$prefix = "dtt"; # prefix for all files
$baseurl = "http://www.unsatisfactorysoftware.co.uk/dtt/dtt.cgi"; # script URL
$cookiedomain = ".unsatisfactorysoftware.co.uk"; # Domain name for setting cookies
$cookiepath = "/dtt"; # Path to be used for cookies
$format = 1; # Default format for mux display mode, number of columns
$by = "lcn"; # Default display format , either "lcn" or "mux"
$defclass = "black"; # CSS style for links
$lightcolour = "#888888"; # light text colour

## You shouldn't need to modify anything below this line.

use Compress::Zlib;
$accept = $ENV{"HTTP_ACCEPT_ENCODING"};

if(!$scriptname)
{
	$scriptname = "$prefix.cgi";
}

$class = $defclass;
$curdate = time;
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($curdate);
$tfhr = ($hour*100)+$min;

$xmas="unsat.gif";

if($mon == 11)
{
	$xmas = "xmasunsat.gif";
}

$lock = 2;
$unlock = 8;
$zapn = 0;

# ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

$copyyr = $year+1900;

$cwkday = $wday;

$wkday{'Sun'} = 0;
$wkday{'Mon'} = 1;
$wkday{'Tue'} = 2;
$wkday{'Wed'} = 3;
$wkday{'Thu'} = 4;
$wkday{'Fri'} = 5;
$wkday{'Sat'} = 6;

&parse_form;

if($FORM{'pr'})
{
	$prefix = $FORM{'pr'};
	$pr = $FORM{'pr'};
}

$filename = $prefix . ".txt";
$cookiename = $prefix . "def";
$regcookiename = $prefix . "reg";

$save = $FORM{'save'}; # save cookies

if(!$save)
{
	%cookies = &getCookies; # store cookies in %cookies
    $defaults = $cookies{$cookiename};
    if($defaults)
    {
        ($agrp,$col,$grp,$type,$mux,$by,$format,$offair) = split(/:/,$defaults);
# $discard - was $reg
    }

    $reg = $cookies{$regcookiename};

	if($reg)
	{
		$cookiereg = $reg;
	}
}

if($FORM{'grp'})
{
	$grp = $FORM{'grp'};  # test grouping timeshares
}

if($FORM{'col'})
{
	$col = $FORM{'col'};
}

if($FORM{'reg'})
{
	$reg = $FORM{'reg'};
}

if($FORM{'type'})
{
	$type = $FORM{'type'};
}

if($FORM{'mux'})
{
	$mux = $FORM{'mux'};
}

if($FORM{'by'})
{
	$by = $FORM{'by'};
}

if($FORM{'hist'})
{
		$hist = $FORM{'hist'};
}

if($FORM{'data'})
{
	$data = $FORM{'data'};
}

if($FORM{'disp'})
{
	$format = $FORM{'disp'};
}

if($FORM{'oair'})
{
	$offair = $FORM{'oair'};
}

if($FORM{'time'})
{
	$tfhr = $FORM{'time'};
}

if($FORM{'change'})
{
	$change = $FORM{'change'};
}

if($FORM{'agrp'})
{
	$agrp = $FORM{'agrp'};
}

$lcn = $FORM{'lcn'};
$prt = $FORM{'prt'};
$pg = $FORM{'pg'};
$sf = $FORM{'sf'};
$search = $FORM{'search'};
$title = $FORM{'title'};
$sort = $FORM{'sort'};
$rsort = $FORM{'rev'};

$typestr = $FORM{'f1'} .  $FORM{'f2'} . $FORM{'f3'} . $FORM{'f4'} . $FORM{'f5'} . $FORM{'p1'} . $FORM{'pp'} . $FORM{'p2'} . $FORM{'p3'} . $FORM{'f6'} . $FORM{'f7'};

$colstr = $FORM{'c1'} . $FORM{'c2'} . $FORM{'c3'} . $FORM{'c4'} . $FORM{'c5'} . $FORM{'c6'} . $FORM{'c7'};

if($typestr)
{
    $type = $typestr;
}

if($colstr)
{
    $col = $colstr;
}

if($data)
{
    $filename = $prefix . $data . ".txt";
}

if($hist)
{
    $filename = $prefix . $hist . ".txt";
}

$typedat = $prefix . ".cols";
$gztypedat = &open_file("FILE1","",$typedat);
$line = &read_file("FILE1",$gztypedat);
@tabledata = split(/\t/,$line);
$dcol = $tabledata[0];
while ($line = &read_file("FILE1",$gztypedat)) {
	chop($line);
	@tabledata = split(/\t/,$line);
    $cid = $tabledata[0];
	$cname{$cid} = $tabledata[1];
#	$cpar{$cid} = $tabledata[2];

	@flags = split(/ /,$tabledata[2]);
	foreach $flag (@flags)
	{
		$cex{$flag} = $cex{$flag} . $cid;
	}

	$cdisp{$cid} = $tabledata[3];
	$chead{$cid} = $tabledata[4];
	$cdef{$cid} = $tabledata[5];
}
close_file(FILE1,$gztypedat);

if(!$col)
{
    $col=$dcol;
}



$typeldat = $prefix . ".typelist";
$chk = 2;

$gztypeldat = &open_file("FILE1","",$typeldat);

while ($line = &read_file("FILE1",$gztypeldat)) {
	@tabledata = split(/\t/,$line);
    $tlid = $tabledata[0];
	$tlname{$tlid} = $tabledata[1];
	chop($tlname{$tlid});

	if($chk == 2)
	{
		if(!$type)
		{
			$type = $tlid;
		}
		$chk = 0;

	}

    $checked = "";

    if($tlid eq $type)
    {
        $checked="selected";
		$chk = 1;
    }

    $tlchecks = $tlchecks . "<option value=\"$tlid\" $checked>$tlname{$tlid}</option>";
}

close_file(FILE1,$gztypeldat);

if(!$chk)
{
	$tlchecks = $tlchecks . "<option value=\"$type\" selected>Custom</option>";
}

$typedat = $prefix . ".types";
$gztypedat = &open_file("FILE1","",$typedat);

while ($line = &read_file("FILE1",$gztypedat)) {
	@tabledata = split(/\t/,$line);
    $tid = $tabledata[0];
	$tname{$tid} = $tabledata[1];
	$tcol{$tid} = $tabledata[2];
	$ttop{$tid} = $tabledata[3];
	$tnamefull{$tid} = $tabledata[4];
	chop($tnamefull{$tid});

	if($tnamefull{$tid} eq "")
	{
		$tnamefull{$tid} = $tname{$tid};
	}

	# setup for lower-case types, level 1 attributes become level 1 attributes
	# level 3 attributes are for name changes only -- not used yet
	# type 1 changes all, and type 2 only changes the colour
	$_ = $tid;
	tr/[A-Z]/[a-z]/; 
	$tname{$_} = $tabledata[1];
	$tcol{$_} = $tabledata[2];
	if (($ttop{$tid} eq "1") | ($ttop{$tid} eq "3"))
	{
		$ttop{$_} = 1;
	}
}

close_file(FILE1,$gztypedat);

$regdat = $filename . ".reg";
$regchecks = "";
$gzregdat = &open_file("FILE1","",$regdat);

$line = &read_file("FILE1",$gzregdat);
@tabledata = split(/\t/,$line);
$rdef = $tabledata[0];
$defrcolour = $tabledata[4];

if($defrcolour eq "")
{
	$defrcolour = "CCCCCC";
}

# set default region if not already specified
if (!$reg) {
	$reg=$rdef;
	$warn = "Please change your region, default view may show channels which are not available in your area.<br>\n";
}
else
{
	$warn = "";
}

$optg = 0;

while ($line = &read_file("FILE1",$gzregdat)) {
	chop($line);
	@tabledata = split(/\t/,$line);
    $rid = $tabledata[0];
	$rname{$rid} = $tabledata[1];
	$ranalogue{$rid} = $tabledata[2];
	$rcolour{$rid} = $tabledata[4];
	if($rcolour{$rid} eq "")
	{
		$rcolour{$rid}=$defrcolour;
	}

	@rgroups = split(/ /,$ranalogue{$rid});
	foreach $rgroup (@rgroups)
	{
		@grpparts = split(/\./,$rgroup);
		$rgroup="";

		foreach $grppart (@grpparts)
		{
			if($grppart ne "")
			{
				$rgroup = $rgroup . "." . $grppart;
				$rgrp{$rgroup} = $rgrp{$rgroup} . $rid . " ";
			}
		}
	}

	if($change && ($ranalogue{$rid} !~ /analogue/))
	{
		if((($change eq "root") && ($rid !~ /\./)) || ((($change . ".") eq substr($rid,0,length($change)+1)) && (substr($rid,length($change)+1) !~ /\./)))
		{
			$actualrid=$rid;

			if($ranalogue{$rid} =~ /map/)
			{
				$actualrid = $tabledata[3];
				$rname{$rid} = "<i>" . $rname{$rid} . "</i>";
			}

			$regionlist = $regionlist . "<tr><td bgcolor=\"#$rcolour{$rid}\"><a class=\"$class\" href=\"$scriptname?reg=$reg&amp;change=$actualrid&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair\">" . $rname{$rid} . "</a></td></tr>\n";

		}
	}

    if($rid eq $reg)
    {
		if($ranalogue{$rid} =~ /map/)
		{
			$reg = $tabledata[3];
		}
    }
}

close_file(FILE1,$gzregdat);

# attempt adding groups using &agrp=.GROUP
#
if($agrp)
{
	$ranalogue{$reg} = $ranalogue{$reg} . " " . $agrp;
}

if($cookiereg && ($change eq "root"))
{
	$cookiername = &expandrname($cookiereg,0);

	if(!$rcolour{$cookiereg})
	{
		$rcolour{$cookiereg} = $defrcolour;
	}
			$regionlist = $regionlist . "<tr><td bgcolor=\"#$rcolour{$cookiereg}\"><b><a class=\"$class\" href=\"$scriptname?reg=$cookiereg&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair\">" . $cookiername . "</a> (Saved Region)</b></td></tr>\n";
}

@region = split(/\./,$reg);
@groups = split(/ /,$ranalogue{$reg});

$muxdat = $filename . ".mux";
$gzmuxdat = &open_file("FILE1","",$muxdat);

$line = &read_file("FILE1",$gzmuxdat);
chop($line);
@tabledata = split(/\t/,$line);
$muxver = $tabledata[0];    
$servname = $tabledata[1];    
$defmuxreg = $tabledata[5];    
$mm = 0;
$muxstr = "";
$newmux = "";

while ($line = &read_file("FILE1",$gzmuxdat)) {
	chop($line);
	@tabledata = split(/\t/,$line);
    $mn = $tabledata[0];
    $mreg{$mn}    = $tabledata[5];

	if($mreg{$mn} eq "")
	{
		$mreg{$mn} = $defmuxreg;
	}

	$found = 0;

	@mr = split(/ /,$mreg{$mn});
	foreach $mrg (@mr)
	{
		$creg = &compreg($mrg);

		if($creg == 2)
		{
			$found = 0;
			last;
		}

		if($creg == 1)   #mrg
		{
			$found = 1;
		}
	}

	if($found == 1)
	{
	    $mm++;
	    $longmn = "mux" . $mn;
   	    $mux = $mux . $FORM{$longmn}; # was $muxstr
       	$allmux = $allmux . $mn;

        $checked = "";

#(($muxstr =~ /$mn/)) ||    ...     && !$muxstr   ...   !$muxstr && 
     	if($mux =~ /$mn/)  # || (!$mux))
       	{
           	$checked="checked";
			$newmux = $newmux . $mn;
		}

       	$msetup{$mn}   = $tabledata[1];
        $muxchecks = $muxchecks . "<td bgcolor=\"#$msetup{$mn}\" align=\"center\"><input type=checkbox name=\"mux$mn\" value=\"$mn\" accesskey=\"$mn\" $checked></td>";
       	$mop{$mn}    = $tabledata[2];
       	$mqam{$mn}    = $tabledata[3];
       	$mfullname{$mn}    = $tabledata[4];
  
		if(!$mfullname{$mn})
		{
			$mfullname{$mn} = $mn;
		}

        $muxnames = $muxnames . "<td align=center bgcolor=\"#$msetup{$mn}\">$mfullname{$mn}</td>";
	}
}

close_file(FILE1,$gzmuxdat);

#if($muxstr)
#{
#	$mux = $muxstr;
#}

if($newmux)
{
	$mux = $newmux;
}

if(!$mux)
{
	$mux=$allmux;
}


if($by ne "mux")
{
    $by = "lcn";
    $bylcn="selected";
}
else
{
    $bymux = "selected";
}

if($save)
{
    &savecookies($save);
}

if($format>1)
{
	$halfmux = length($mux)/$format;
#	if(int($halfmux)<$halfmux)
#	{
#		$halfmux++;
#	}
		$halfmux = int($halfmux);
}

$dcol=$col;

if($by eq "mux")
{
	$col =~ s/$cex{'nomux'}//g;
}

if($grp eq "tl")
{
	$col =~ s/$cex{'notl'}//g;
}

if($grp)
{
	$col =~ s/$cex{'nogrp'}//g;
}

&getchannelnames;
&getnewtimeshares;

if($lcn)
{
	$servname = $servname . ": " . $chname[$lcn];
}

print "Content-type: text/html; charset=ISO-8859-1\n";

if($accept =~ /gzip/)
{
	$gzip = 1;
	print "Content-Encoding: gzip\n\n";

binmode STDOUT;

$gz = gzopen(\*STDOUT, "wb")
	  or die "Cannot open stdout: $gzerrno\n" ;

}
else
{
	$gzip = 0;
	print "\n";
}

if(!$prt)
{
	$dfile = $prefix . ".top";
	disp_file($dfile,"");

#	gzprint("<tr><td><b><a class=\"$class\" href=\"$scriptname?reg=$reg&amp;change=root&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair\">Region:</a></b></td>");

}
else
{

&gzprint("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n\"http://www.w3.org/TR/html4/loose.dtd\">\n<html>\n<head>\n<meta name=\"robots\" content=\"INDEX,NOFOLLOW\">\n<title>$servname</title>\n<style type=\"text/css\">\n<!--\n");
&gzprint("body               {color           : black;\n");
&gzprint("                    background      : white;\n");
&gzprint("                    font-family     : sans-serif}\n");
&gzprint("a                  {color           : black;\n");
&gzprint("                    text-decoration : none}\n");
&gzprint("a.light            {color           : $lightcolour}\n");
&gzprint("body.light         {color           : $lightcolour}\n");
&gzprint("-->\n</style>\n</head>\n<body bgcolor=\"#FFFFFF\" link=\"#000000\" vlink=\"#000000\" text=\"#000000\">\n");

	&gzprint("<table class=\"normal\" border=\"0\"><tr><td><b>$servname &raquo;</b></td>");

}

if($change)
{
	&gzprint("<b>");
	&gzprint(&expandrname($change,1));
	&gzprint("</b>");

	if($change ne "root")
	{

		&gzprint(" <a href=\"$scriptname?reg=$change&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&save=1\">[Save]</a>");
		&gzprint(" <a href=\"$scriptname?reg=$change&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair\">[Use]</a>");
		&gzprint(" <a href=\"$scriptname?reg=$reg&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair\">[Cancel]</a>");
	}

	&gzprint ("<table class=\"normal\" border=0 width=\"100%\">\n");
	&gzprint("<p>$regionlist");
	&gzprint("</table>");
	&cpymsg;
	exit;
}

$curreg = &expandrname($reg,1);

if(!$prt)
{
	&gzprint("<table class=\"normal\" border=\"0\"><tr>");
}

&gzprint("<td bgcolor=\"#$rcolour{$reg}\"><b>$curreg</b></td><td><a href=\"$scriptname?reg=$reg&amp;change=root&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair\">[Change Region]</a></td></tr></table><br>\n$warn");

&gzprint("<form method=\"post\" action=\"$scriptname\">\n<table class=\"normal\" border=0>\n<tr><td align=center>Show</td><td align=center>Sort by</td>$muxnames<td>&nbsp;</td></tr>\n<tr><td>\n<select name=\"type\">\n$tlchecks\n</select>\n</td>\n");
&gzprint("<td><select name=\"by\">\n<option value=\"lcn\" $bylcn>LCN</option>\n<option value=\"mux\" $bymux>Mux</option>\n</select></td>\n$muxchecks\n<td>\n<input name=\"col\" value=\"$dcol\" type=hidden>\n<input name=\"grp\" value=\"$grp\" type=hidden>\n<input name=\"hist\" value=\"$hist\" type=hidden>\n<input name=\"data\" value=\"$data\" type=hidden>\n<input name=\"pr\" value=\"$pr\" type=hidden>\n<input name=\"disp\" value=\"$format\" type=hidden>\n<input name=\"oair\" value=\"$offair\" type=hidden>\n<input name=\"agrp\" value=\"$agrp\" type=hidden>\n<input name=\"reg\" value=\"$reg\" type=hidden>\n<input type=submit value=\"List\">\n</td></tr></table></form>\n<hr>\n");

if($pg)
{
	if($pg =~ /.html/){
		$filename = $pg;
	}
	else
	{
    	$filename = $prefix . "." . $pg . ".txt";
	}

	disp_file($filename,"update");
	&cpymsg;
	exit;
}

if($hist)
{
	&gzprint ("<b>This is historic data \"$hist\".  Click <a href=\"$scriptname?reg=$reg&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair\">here</a> for current information.</b>\n");
}
else
{
	disp_file($filename . ".msg","");
}

$counter = 0;
$totline = 0;

$lmux = $mux;

if($by eq "mux")
{
	$nmuces=0;
	$round=1;
	if($format>1)
	{
		&gzprint ("<table class=\"normal\" border=0 width=\"100%\"><tr><td valign=\"top\">\n");
	}

    @muxes = split(//,$mux);
    foreach $mux (@muxes) {
		$nmuces++;
		$prtheader=1;
		&checkall;
		if ($prtheader == 0)
    	{
			if(($format>1 && $format>$round) & ($nmuces >= $halfmux))
			{
				$round++;
				&gzprint ("</table>\n</td><td valign=\"top\">\n<table class=\"normal\" border=0 width=\"100%\">");
				$nmuces=0;
			}
			else
			{
	    		&gzprint ("<tr bgcolor=\"#FFFFFF\"><td>&nbsp;</td></tr>");
    		}
	    }
	    $mux=$lmux;
	}
	if($format>1)
	{
		&gzprint ("</td></tr></table>\n");
	}
}
else
{
	&checkall;
}

if ($counter == 0) {
	&gzprint ("<p><b>No Channels Found</b><br>Please select some different options and try again.<hr>\n");
}
else
{
	&gzprint ("</table>\n");
}

# $totline = $totline -1;   # first line is the header

&cpymsg;

sub print_record {

	$timeshares = "";
	$tslcn="";
	$tstable="";
	$tstimes="";
	$ctime = 0;

	if($nstimeshares[$data{'L'}])
	{
		$data{'S'} = $nstimeshares[$data{'L'}];
	}

	if($data{'S'})
	{
    	@ts = split(/ /,$data{'S'});
    	foreach $timeshare (@ts)
    	{
	    	@tsreg = split(/:/,$timeshare);

			$creg = &compreg($tsreg[1]);

			if($creg == 2) {last;}

			if($creg == 1)
			{
				$timeshare = $tsreg[0];
			}
			else
			{
				$timeshare = 0;
			}

#			if($timeshare =~ /$reg/)
#			{
#				$timeshare = substr($timeshare,1);
#			}

			if($timeshare > 0)
			{
				if($timeshares ne "")
				{
					$timeshares = $timeshares . "<br>";
					$tstable = $tstable . ", ";
				}

	        	$timeshares = $timeshares . "<a href=\"$scriptname?reg=$reg&amp;lcn=$timeshare&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\" class=\"$class\">$chname[$timeshare]</a>";
    	    	$tstable = $tstable . "$chname[$timeshare]";
        		if($grp eq "tl")
        		{
	            	@btimes = split(/-/,$times[$timeshare]);
    	        	$btime = $btimes[1] - $btimes[0];
        	    	if ($btime < 0)
            		{
                		$btime = $btime + 2400;
	            	}
	
					$btime = int(($btime/2400) * 100);
	    	        $ctime = $ctime + $btime;
	        	    $tslcn = $tslcn . "<td width=\"$btime%\">$timeshare $chname[$timeshare]</td>";

				}
	        	else
	        	{
	        		$tslcn = $tslcn . "<br><a href=\"$scriptname?reg=$reg&amp;lcn=$timeshare&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\" class=\"$class\">$timeshare</a>";
        
	        	}
	        	$tstimes = $tstimes . "<br>$times[$timeshare]</a>";
	        	$zap[$zapn] = $timeshare;
	        	$zapn++;
	    	}
		}
	}

	$chtype = "";
	$class = "black";

	@splt = split(//, $data{'T'});
	foreach $code (@splt)
	{
		if($ttop{$code})
		{
			if($ttop{$code} != 3)
			{
				$setup = "\n<tr bgcolor=\"#$tcol{$code}\">";
			}
			if($ttop{$code} != 2)
			{
				$chtype = $tname{$code};
				$code =~ tr/[a-z]/[A-Z]/; 
				$littletype = $code;
			}
		}
		else
		{
			if($tcol{$code} eq "*")
			{
				$class = "light";
			}
		}
	}

	$fulltype = "<a href=\"$scriptname?reg=$reg&amp;by=$by&amp;type=$littletype&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\" class=\"$class\">$chtype</a>";  # &mux=$mux
	$fullmux = "<a href=\"$scriptname?reg=$reg&amp;by=mux&amp;mux=$data{'M'}&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\" class=\"$class\">$mfullname{$data{'M'}}</a>"; # &type=$type
	if($data{'W'})
    {
        $fullname = "<a href=\"http://$data{'W'}\" target =\"_new\" class=\"$class\">$data{'N'}</a>";
    }
    else
    {
		if($class eq "light")
		{
			$fullname = "<font color=\"$lightcolour\">" . $data{'N'} . "</font>";
		}
		else
		{
        	$fullname = $data{'N'};
		}
    }

	if($by eq "mux")
	{
		#        $setup = "<tr bgcolor=\"#AAAAAA\">";
		#        @data = ("Unknown","");

		$setup = "\n<tr bgcolor=\"#$msetup{$data{'M'}}\">";
        @data = ($mop{$data{'M'}},$mqam{$data{'M'}});
	}


	# new tabled format

	if($lcn)
	{
		$fulllcn = $data{'L'};
		if($counter==1)
        {
            &gzprint ("<table class=\"normal\" border=0 width=\"100%\">");
        }

		$avail = "";

		@splt = split(/ /, $data{'R'});

		foreach $code (@splt)
		{
			$code =~ tr/a-z/A-Z/d;
			$fullrname = &expandrname($code);

			if(substr($code,0,1) eq ".")
			{
				$avail = $avail . $fullrname;
			}
			else
			{
				$avail = $avail . "<a href=\"$scriptname?reg=$code&amp;by=$by&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\" class=\"$class\">$fullrname</a><br>";
			}
		}

		$savail = "";

		$fulltype = "";
		@splt = split(//, $data{'T'});
		foreach $code (@splt)
		{
			$_ = $code;
			tr/[a-z]/[A-Z]/; 
			$fulltype = $fulltype . "<a href=\"$scriptname?reg=$reg&amp;by=$by&amp;type=$_&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\" class=\"$class\">$tnamefull{$_}</a><br>";
		}
		$tstable = $timeshares;
		for($ec = 0; $ec < $maxcol ; $ec++)
		{
			if($cname{$var[$ec]})
			{
				&gzprint ("$setup<td valign=\"top\">$cname{$var[$ec]}</td><td>");
				if($cdisp{$var[$ec]})
				{
					$_ = $cdisp{$var[$ec]};
					s/\$(\w+)/${$1}/g;

					if(!$_)
					{
						$_ = "&nbsp;";
					}

					&gzprint ("$_");
				}
				else
				{
					if($tabledata[$ec])
					{
						&gzprint ("$tabledata[$ec]");
					}
					else
					{
						if($cdef{$var[$ec]})
						{
							&gzprint("$cdef{$var[$ec]}");
						}
						else
						{
							&gzprint ("&nbsp;");
						}
					}
				}
				&gzprint ("</td></tr>");
			}
		}

#		foreach $datatype (
#    $cid = $tabledata[0];
#	$cname{$cid} = $tabledata[1];
#		disp_file("dtt.lcn");

	}
	else
	{
		if($search)
		{
			$reg = $data{'R'};
			#$subreg = $data{'r'};
		}

		$fulllcn = "<a href=\"$scriptname?reg=$reg&amp;lcn=$data{'L'}&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\" class=\"$class\">$data{'L'}</a>";

	    if(($counter==1) || ($prtheader==1))
    	{
        	if($counter==1)
        	{
            	&gzprint ("<table class=\"normal\" border=0 width=\"100%\">");
        	}
        	$prtheader=0;
        	if($by eq "mux")
        	{

				if (length($col)>=3)
				{
					&gzprint ("${setup}<td>Mux&nbsp;$mfullname{$data{'M'}}</td><td>$data[0]</td><td>$data[1]</td></tr>${setup}");
				}
				else
				{
					&gzprint ("${setup}<td>Mux&nbsp;$mfullname{$data{'M'}} ($data[0]) $data[1]</td></tr>${setup}");
				}

				#print "</tr>";
			}
        	else
        	{        
				&gzprint ("<tr>");

			}

    			$muxlink = "<a href=\"$scriptname?reg=$reg&amp;by=mux&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\" class=\"$class\">Mux</a>";

    			$lcnlink = "<a href=\"$scriptname?reg=$reg&amp;by=lcn&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\" class=\"$class\">LCN</a>";

				@splt = split(//, $col);
				foreach $code (@splt)
				{
						if($chead{$code})
						{
							$_ = $chead{$code};							
							s/\$(\w+)/${$1}/g;
							&gzprint ("<td><b>$_");
						}
						else
						{
							&gzprint ("<td><b>$cname{$code}");
						}

				
						if($cex{'sort'} =~ /$code/)
						{
							&gzprint ("&nbsp;<a href=\"$scriptname?reg=$reg&amp;by=$by&amp;type=$type&amp;mux=$lmux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp&amp;sort=$code\">v</a>");
						}

						&gzprint ("</b></td>");

				}





		}

		if($grp)
		{
    		if($grp eq "tl")
    		{
            	if($data{'H'} eq "24hr")
            	{
                	$btime = 100;
            	}
            	else
            	{
                	@btimes = split(/-/,$data{'H'});
                	$btime = $btimes[1] - $btimes[0];
                	if ($btime < 0)
                	{
                    	$btime = $btime + 2400;
                	}

					$btime = int(($btime/2400) * 100);
            	}

	            $ctime = 100 - ($btime + $ctime);
		        $fulllcn = "<table class=\"normal\" width=\"100%\"><tr width=\"100%\" bgcolor=\"#FFFFFF\"><td width=\"$btime%\">$fulllcn $fullname</td>$tslcn";

		        if($ctime>1)
        		{
        			$fulllcn = $fulllcn . "<td width=\"$ctime%\">&nbsp;</td>";
        		}

		        $fulllcn = $fulllcn . "</tr></table>";
    		}
    		else
    		{
        		$fulllcn = $fulllcn . $tslcn;
        		$fullname = $fullname . "<br>" . $timeshares;
        		$data{'H'} = $data{'H'} . $tstimes;
    		}
		}

		&gzprint ("${setup}");





				@splt = split(//, $col);
				foreach $code (@splt)
				{
						if($cdisp{$code})
						{
							$_ = $cdisp{$code};							
							s/\$(\w+)/${$1}/g;
							if(!$_)
							{
								$_ = "&nbsp;";
							}
							&gzprint ("<td>$_</td>");
						}
						else
						{
							if(!$data{$code})
							{
								$data{$code} = "&nbsp;";
							}

							if($class eq "light")
							{
								&gzprint ("<td><font color=\"$lightcolour\">$data{$code}</font></td>");
							}
							else
							{
								&gzprint ("<td>$data{$code}</td>");
							}
						}
					}

		&gzprint ("</tr>");
	}

}

sub check_record {

	$found=0;

	for($ec = 0; $ec < $maxcol ; $ec++)
	{
		$data{$var[$ec]} = $tabledata[$ec];
#		$alldata[$ec]=$tabledata[$ec];
	}

	if($sort)
	{

#print "$sorted[$cursortcheck] = $cursortcheck = $data{$sort} ** ";

		if($sorted[$cursortcheck] == $data{$sort})
		{
			if($cursortcheck >= $#sorted)
			{
				return;
			}
			$cursortcheck++;
		}
		else
		{
			return;
		}
	}

	if($offair > 0)
	{
		$hourchk = $data{'H'};

		if($data{'H'} =~ /^(Mon|Tue|Wed|Thu|Fri|Sat|Sun)/)
		{
			@timesplit = split(/\s/,$data{'H'});

			$g=0;

			foreach $timegroup (@timesplit)
			{
				$g++;

				if($timegroup =~ /^(Mon|Tue|Wed|Thu|Fri|Sat|Sun)/g)
				{
					if($wkday{$1} < $wkday{$2})
					{
						if(($cwkday >= $wkday{$1}) & ($cwkday <= $wkday{$2}))
						{
							$hourchk = $timesplit[$g];
						}
					}
					else
					{
						if(($cwkday <= $wkday{$1}) | ($cwkday >= $wkday{$2}))
						{
							$hourchk = $timesplit[$g];
						}
					}
				}
			}
		}

		if($hourchk ne "24hr")
    	{
			$onair = 0;

			@timesplit = split(/\s/,$hourchk);

			foreach $timegroup (@timesplit)
			{
				@btimes = split(/-/,$timegroup);

				if((($btimes[0] < $btimes[1]) & (($tfhr < $btimes[0]) | ($tfhr >= $btimes[1]))) | (($btimes[1] < $btimes[0]) & (($tfhr < $btimes[0]) & ($tfhr >= $btimes[1]))) | $timegroup =~ /Various/)
				{
# do nothing
				}
				else
				{
					$onair = 1;
				}
			}
			if($onair == 0)
			{
				if($offair == 1)
				{
					$data{'T'} = $data{'T'} . "O";
				}

				if($offair == 2)
				{
					$data{'T'} =~ tr/[A-Z]/[a-z]/;
					$data{'T'} = $data{'T'} . "O";
				}
			}
		}
	}

	if($search)
	{
		if($sf)
		{
			if($data{$sf} =~ /$search/i)
			{
				$found = 1;
			}
		}
		else
		{
			if($line =~ /$search/i)
			{
				$found = 1;
			}
		}
	}
	else
	{
		@datareg = split(/ /,$data{'R'});

		foreach $datreg (@datareg)
		{
			$creg = &compreg($datreg);

			if($creg == 2)
			{
				$found = 0;
				last;
			}

			if($creg == 1)
			{
				if($lcn)
	    		{
    	    		if($lcn == $data{'L'})
        			{
						$found = 1;
	        		}
    			}
				else
	    		{
    	    		if ($type)
	    	    	{
    	    	    	@chars = split(//,$data{'T'});
						foreach $aword (@chars) {
							if ($type =~ /$aword/) {   #/i
    		            		$found = 1;
							}
						}
					}
	
					if (($found==1) || (!$type))
					{
						$found = 0;
						if (($data{'M'} && ($mux =~ /$data{'M'}/)) | ((!$data{'M'}) & ($by eq "lcn"))) {
							$found = 1;
						}
					}
				} # end else

				if($grp)
				{
    				foreach $zapped (@zap)
    				{
        				if($zapped == $data{'L'})
		        		{
    		        		$found = -1;
        				}
					}
				}
	
				if($found == -1)
				{
					$found = 0;
				}
			}
		}
	}
}

sub parse_form {

	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	if (length($buffer) < 5) {
		$buffer = $ENV{QUERY_STRING};
	}

	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) {
    	($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$FORM{$name} = $value;
	}
}

sub checkall {

	if($sort)
	{
		$cursortcheck = 0;

		while($cursortcheck < $#sorted)
		{

#print "$cursortcheck < $#sorted\n";

			&checkallrecords;
		}
	}
	else
	{
		&checkallrecords;
	}
}

sub checkallrecords {

#	while ($line = &read_file("FILE1")) { #&& ($counter < $results)) {

	foreach $line (@chfile)
	{
		# chop($line); #$data{$var[$maxcol]});

#print "$line<br>\n";

		@tabledata = split(/\t/,$line); # ,$fields);
		&check_record;

		if ($found == 1) {
			$counter++;
			&print_record;
		}
	}
#    close(FILE1);
}

sub getnewtimeshares {
	@tsfile=();
	$tsfilename = $filename . ".shares";

	$tsgzfilename = &open_file("FILE1","",$tsfilename);
	if($tsgzfilename)
	{
		$tsfilename .= ".gz";
	}
	while($tline = &read_file("FILE1",$tsgzfilename))
	{
		push(@tsfile,$tline);
	}
    close_file(FILE1,$tsgzfilename);

	$line = shift(@tsfile);
	chop($line);
	@splt = split(/\t/,$line);
	$tsdefreg = $splt[0];

	foreach $line (@tsfile)
	{
		chop($line);
		# split the fields at the tab character
		@tsdata = split(/\t/,$line);

		if($tsdata[0] eq "")
		{
			$tsdata[0] = $tsdefreg; # region
		}

		$tsindex = 0;

		@splitreg = split(/ /,$tsdata[0]);

		foreach $sptreg (@splitreg)
		{
			$creg = &compreg($sptreg);

			if($creg == 2) {last;}

			if($creg == 1)
			{
				@splitchs = split(/ /,$tsdata[1]);

				foreach $tschannel (@splitchs)
				{
					$nstimeshares[$tschannel] = "";

					if($tsindex < $#splitchs)
					{
						for($tschentry = $tsindex + 1; $tschentry <= $#splitchs; $tschentry++)
						{
							$nstimeshares[$tschannel] .= $splitchs[$tschentry] . " ";
						}
					}

					if($tsindex > 0)
					{
						for($tschentry = 0; $tschentry < $tsindex; $tschentry++)
						{
							$nstimeshares[$tschannel] .= $splitchs[$tschentry] . " ";
						}
					}

					$tsindex++; # where we are in the list
				}
			}
		} #split reg - need to break out of this if matched already
	}

}

sub getchannelnames{
	@chfile=();
	$gzfilename = &open_file("FILE1","",$filename);
	if($gzfilename)
	{
		$filename .= ".gz";
	}
	while($tline = &read_file("FILE1",$gzfilename))
	{
		push(@chfile,$tline);
	}
#	@chfile = <FILE1>;
    close_file(FILE1,$gzfilename);

	$line = shift(@chfile); # $chfile[0]; #&read_file("FILE1");
	chop($line);
	$coln = 0;
	$collist = "";
	@splt = split(/\t/,$line);
	foreach $colhead (@splt)
	{
		@firstchar = split(//,$colhead);
		$var[$coln] = $firstchar[0];
		$vars{$firstchar[0]} = $coln;
		$coln++;

		if($cname{$firstchar[0]})
		{
	    	$collist = $collist . "<option value=\"$firstchar[0]\">$cname{$firstchar[0]}</option>";
		}
	}
	$maxcol = $coln;

	$i = 0;

    #while ($line = &read_file("FILE1")) {  #&& ($counter < $results)) {

	foreach $line (@chfile)
	{
		chop($line);
		#$totline++;
		# split the fields at the tab character
		@tabledata = split(/\t/,$line); # ,$fields);

		chop($tabledata[$maxcol]);

		@splitreg = split(/ /,$tabledata[$vars{'R'}]);

		foreach $sptreg (@splitreg)
		{
			$creg = &compreg($sptreg);

			if($creg == 2) {last;}

			if($creg == 1)
			{
				$chname[$tabledata[$vars{'L'}]] = $tabledata[$vars{'N'}];
				$times[$tabledata[$vars{'L'}]] = $tabledata[$vars{'H'}];
			}
		}

		if($sort)
		{
			if(($cex{'sort'} =~ /$sort/) & ($vars{$sort}))
			{
				$datatosort[$i] = $tabledata[$vars{$sort}];
				$i++;
			}
			else
			{
				$sort = "";
			}
		}
	}

	if($sort)
	{
		if($rsort)
		{
#			@sorted = reverse sort sortall @datatosort;
		}
		else
		{
			@sorted = sort {$a <=> $b} @datatosort;  # was sort sortall @
		}
	}
}

sub sortall
{
	if(($a <=> $b) == 0)
	{
		return(lc($a) cmp lc($b));
	}
	else
	{
		return($a <=> $b);
	}
}

sub open_file {
	local ($filevar, $notused, $filen) = @_;
	my $gzf;

	if (!open($filevar,$filen))
	{
		$filen .= ".gz";
		if($notused eq "update")
		{
			$filename = $filen;
		}

		$gzf = gzopen($filen,"r"); # || die "cannot open file";
		return($gzf);
	}
	return(0);
}

sub read_file {
	local ($filevar,$gzf) = @_;
	my $buffer;

	if(!$gzf)
	{
		return <$filevar>;
	}
	else
	{
		if($gzf->gzreadline($buffer))
		{
			return($buffer);
		}
		else
		{
			return(0);
		}
	}
}

sub close_file {
	local($filevar,$gzf) = @_;
	if(!$gzf)
	{
		close($filevar);
	}
	else
	{
		$gzf->gzclose();
	}

}

sub disp_file {
	local($filen,$update) = @_;

	$gzdispfile = &open_file("MSG",$update,$filen);

#	@text = <MSG>;

#  	flock (MSG, $unlock);
#  	close(MSG);

	#foreach $text (@text)
	while ($text = &read_file("MSG",$gzdispfile))
	{
		if(!($filen =~ /.html/))
		{
    		$text =~ s/\$(\w+)/${$1}/g;
		}
		&gzprint ("$text");
	}

	close_file(MSG,$gzdispfile);
}


sub savecookies {

	local ($a) = @_;

	$curdate = time;
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(315360000+$curdate);
	@months = (Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec);
	@wdays = (Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday);
	$year = $year + 1900;
	$expdate = "$wdays[$wday], $mday-$months[$mon]-$year $hour:$min:$sec GMT";

	$cookiestr = "$agrp:$col:$grp:$type:$mux:$by:$format:$offair";

	if($a == 1)
	{
		&setCookie($regcookiename,$reg, $expdate, $cookiepath, $cookiedomain);
	}

	if($a == 2)
	{
		&setCookie($cookiename, $cookiestr, $expdate, $cookiepath, $cookiedomain);
	}
}

sub setCookie {
	local($name, $value, $expiration, $path, $domain) = @_;
	# ,$secure for https: only

    print "Set-Cookie: ";
    print $name . "=" . $value . "; expires=" . $expiration . "; path=" . $path . "; domain=" . $domain . "; " . $secure . "\n";
}

sub getCookies {
	# cookies are seperated by a semicolon and a space, this will split
    # them and return a hash of cookies
    local(@rawCookies) = split (/; /,$ENV{'HTTP_COOKIE'});
    local(%cookies);

    foreach(@rawCookies){
        ($key, $val) = split (/=/,$_);
        $cookies{$key} = $val;
    }

    return %cookies;
}

sub gzprint {
	local($text) = @_;

	if($gzip)
	{
		$gz->gzwrite($text) 
			or die "error writing: $gzerrno\n" ;
	}
	else
	{
		print $text;
	}
}

sub compreg
{
	local ($sysreg) = @_;
	local $a = 0;
	local $match = 0;

	local $retcode = 1;

	if((substr($sysreg,0,1) eq "!") && (substr($sysreg,1) eq $reg))
	{
		return(1);
	}

	if(substr($sysreg,0,1) eq "~")
	{
		$sysreg = substr($sysreg,1);
		$retcode = 2;
		# return(2);
	}

	@sysregarray = split(/\./,$sysreg);

	if(substr($sysreg,0,1) eq ".")
	{
		foreach $group (@groups)
		{
			$a=0;
			@grparray = split(/\./,$group);

			foreach $sysreg (@sysregarray)
			{
				if(($sysreg eq $grparray[$a]) || $sysreg eq "*")
				{
					$match=1;
				}
				else
				{
					$match=0;
					last;
				}
				$a++;
			}

			if($match==1)
			{
				return($retcode);
			}

#			if($sysreg eq $group)
#			{
#				return(1);
#			}
		}
		return(0);
	}

	$a = 0;

	foreach $sysreg (@sysregarray)
	{
		if(($sysreg ne $region[$a]) && ($sysreg ne "*"))
		{
			return(0);
		}
		$a++;
	}

	return($retcode);
}

sub expandrname
{
	local ($code,$links) = @_;

	local $fullrname = "";

	if(substr($code,0,1) eq ".")
	{
		if($links == 1)
		{
			return("");
		}

		@groupregions = split(/ /,$rgrp{$code});
		foreach $groupregion (@groupregions)
		{
			$fullrname = $fullrname . "<a href=\"$scriptname?reg=$groupregion&amp;by=$by&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\" class=\"$class\">" . &expandrname2($groupregion,$links) . "</a><br>";
		}
	}
	else
	{
		$fullrname = &expandrname2($code,$links);
	}

	return($fullrname);
}

sub expandrname2
{
	local ($code,$links) = @_;

	local $fullrname = "";
	local $inccode = "";
	local $special1 = "";
	local $special2 = "";

	if(substr($code,0,1) eq "~")
	{
		$code =~ tr/~//d;
		$special1 = "except ";
	}

	if(substr($code,0,1) eq "!")
	{
		$code =~ tr/!//d;
		$special2 = " (only)";
	}

	foreach $codepart (split(/\./,$code))
	{
		if($inccode ne "")
		{
			$inccode = $inccode . ".";
		}

		$inccode = $inccode . $codepart;
		if($fullrname ne "")
		{
			$fullrname = $fullrname . ": ";
		}

		if($links)
		{
			$fullrname = $fullrname . "<a class=\"$class\" href=\"$scriptname?reg=$reg&amp;change=$inccode&amp;by=$by&amp;type=$type&amp;mux=$mux&amp;hist=$hist&amp;data=$data&amp;col=$dcol&amp;disp=$format&amp;grp=$grp&amp;oair=$offair&amp;agrp=$agrp\">";
		}

		if($rname{$inccode})
		{
			$fullrname = $fullrname . $rname{$inccode};
		}
		else
		{
			$fullrname = $fullrname . "<i>" . $codepart . "</i>";
		}

		if($links)
		{
			$fullrname = $fullrname . "</a>";
		}
	}
	return($special1 . $fullrname . $special2);
}


sub cpymsg {

	$filedate = (stat($filename))[9];

	@months = (January,February,March,April,May,June,July,August,September,October,November,December);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($filedate);

	$yr = $year+1900;

	$updated = "$mday $months[$mon] $yr";

	$qlink = "$baseurl?";

	if ($pg)
	{
    	$qlink = $qlink . "pg=${pg}";
	}
	elsif($lcn)
	{
    	$qlink = $qlink . "reg=$reg&amp;lcn=${lcn}";

	    if($hist)
    	{
        	$qlink = $qlink . "&amp;hist=" . $hist;
    	}

	    if($data)
    	{
        	$qlink = $qlink . "&amp;data=" . $data;
    	}
	}
	else
	{
    	$qlink = $qlink . "reg=$reg&amp;by=${by}&amp;mux=${mux}&amp;col=$dcol";

	    if($grp)
    	{
        	$qlink = $qlink . "&amp;grp=$grp";
    	}

	    if($type)
    	{
        	$qlink = $qlink . "&amp;type=" . $type;
    	}

	    if($format>1)
    	{
        	$qlink = $qlink . "&amp;disp=" . $format;
    	}

	    if($hist)
    	{
        	$qlink = $qlink . "&amp;hist=" . $hist;
    	}

	    if($data)
    	{
    	$qlink = $qlink . "&amp;data=" . $data;
    	}

	    if($pr)
    	{
        	$qlink = $qlink . "&amp;pr=" . $prefix;
    	}

	    if($offair)
    	{
        	$qlink = $qlink . "&amp;oair=" . $offair;
    	}

	    if($sort)
    	{
        	$qlink = $qlink . "&amp;sort=" . $sort;
    	}

	    if($agrp)
    	{
        	$qlink = $qlink . "&amp;agrp=" . $agrp;
    	}

	}

	if($counter != 1)
	{
    	$ess = "s";
	}

	if(!$counter)
	{
    	$chcount = $ver;
	}
	else
	{
    	$chcount = "$counter Channel$ess";
	}

	if(!$prt)
	{
		$dfile = $prefix . ".bot";
		disp_file($dfile,"");
	}
	else
	{
		&gzprint("<hr>\nLast updated: $updated | $baseurl | $chcount\n</body>\n</html>\n");
	}

	if($gzip)
	{
		$gz->gzclose;
	}

}
